Subject: Re: [APPS-REVIEW] Review of HTTP Binding for DSKPP

From: Hannes Tschofenig <[email-masked]>
Date: Tue, 02 Oct 2007 10:25:09 +0200

Hi Julian,

I believe the first thing is to get some feedback from this group 
whether they think some of my observations are indeed correct.
If the suggestions in RFC 3205 (BCP 56) are still correct then I suspect 
we need to modify a few protocols.
(I also realize that BCP 56 is not providing strict rules but at least I 
got confused by the guidelines it provides.)

Ciao
Hannes

Julian Reschke wrote:
> Hi,
>
> thanks for the overview.
>
> If that document indeed argues against new methods, for new URI 
> schemes and for usage of WSDL it seems it needs to be either fixed or 
> marked historic.
>
> Maybe it's something for HTTPbis to look at?
>
> Best regards, Julian

_______________________________________________
APPS-REVIEW mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/apps-review

---

From: Chris Newman <[email-masked]>
Date: Tue, 02 Oct 2007 18:46:31 -0700

Hannes Tschofenig wrote on 9/30/07 12:19 +0200:
> thank you Chris for the pointer to RFC 3205 (BCP 56). I now read it and it is
> indeed a very interesting document. Too bad that I didn't came across it
> earlier.
> Reading through that document I got the impression that the suggestions that
> can be found in there are not exercised by today's protocol designs.

I largely support BCP 56 and as an IESG member I consider it my duty and within 
my authority to enforce that BCP using my best judgment.  However, some of the 
advice it gives could be updated to make it better and it could use advice in 
additional areas -- I would support an effort to revise it, although the 
present HTTP WG proposal may not be the right place to do that work.  I'm 
uncomfortable when my best technical judgment disagrees with common practice 
and am unlikely to use my IESG authority to permanently block forward progress 
on a document in that case.  However, when I'm aware of a BCP rule and agree 
with it, I consider it my duty at a minimum to verify the community considered 
the rule and had explicit community rough consensus to violate it.

> (c) New port number for DSKPP since the usage is so different from ordinary
> HTTP webbrowsing
> (This is quite controversal when it comes to firewall traversal and might
> require more discussions. See
> http://www1.ietf.org/mail-archive/web/apps-review/current/msg00090.html)
>
> None of the protocols I have been working on defines a new port. Can you give
> a reference to a recently developed protocol that carries XML on top of HTTP
> that uses a new port number?

I'll give two examples of HTTP-based protocols with separate ports where that 
was clearly the right technical choice in my opinion:
  IPP: RFC 2910
  SIP: RFC 3261

I'll also mention that the Mail Submission protocol runs on port 587 primarily, 
but can also run on port 25.  That's a practical way to (1) remain backwards 
compatible with deployed usage or limitations. (2) provide a separate port when 
it's helpful to avoid middle-box restrictions on an overused/abused port like 
port 25.

It's my technical opinion there should be a separate port registered for HTTP 
access to information used to validate security credentials (CRLs, OCSP, etc) 
with port 80 as a fallback for situations where the separate port can't be used 
and for legacy use.  It's plausible to build an Internet service where port 80 
was intercepted by default for the authentication screen, but this other port 
was (partially) open so a client can get security information necessary to 
verify the interception HTTP server's credentials.  I think that would be a 
better architecture than running everything over port 80 and forcing the port 
80 application-level middle-boxes to become ever more sophisticated and failure 
prone.

I have voted DISCUSS for discussion on this topic with document authors, but I 
have not yet blocked forward progress on any documents on this basis.

> (d) New URI scheme
> (Currently we use the HTTP/HTTPS schemes but that does not seem to be inline
> with the recommendations in BCP 56.)
>
> Neither HELD, SCVP, LoST nor DSKPP define a new URI scheme. In LoST we had a
> URL registration in the document once, see Section 16.5 of
> draft-ietf-ecrit-lost-03, but removed it later (co-author of that document is
> Ted Hardie, the former Applications Area Director).

For things that only run on port 80, I generally wouldn't expect a separate URL 
scheme.

> (e) WSDL Usage: Lisa and Chris do not see WSDL as something being useful. In
> fact, I haven't found a person who argued in favor of WSDL. Hence, I believe
> we should avoid it.

To be precise: I have not yet seen any evidence that WSDL is useful.  However, 
I have not educated myself on the protocol sufficiently to have formed an 
opinion on whether or not it is useful.

> (f) Error Codes: RFC 3205 points to the problems of defining error codes when
> applications are layered on top of HTTP. The suggestion is to essentially
> only use 200 (for complete success) and 500 (for complete failure) at the
> HTTP layer and to use "application" specific error codes inside the layer
> application itself. We are essentially doing this. The only other error
> message that is being mentioned is 403 and since it is independent of the
> DSKPP protocol interaction it should be fine as well.
>
> (g) HTTP client, proxy and server code: We added text regarding the expected
> behavior of clients, proxies and server in Section 5 of
> http://www.ietf.org/internet-drafts/draft-ietf-keyprov-dskpp-00.txt. I guess
> we are doing fine there.
>
> I am OK with (a), (b), (e), (f) and (g). I am not sure about (c) and (d).
> Help needed.
>
> Ciao
> Hannes
>
> PS: Regarding Mime-Types:
>
> In KEYPROV with the DSKPP document we should use application/dskpp+xml
> instead of application/vnd.ietf.keyprov.dskpp+xml
>
> The IANA registry for the MIME type should look similar to the one in Section
> 17.2 of draft-ietf-ecrit-lost-06.
>
> We also need to add a registry for the schema and the namespace (see Section
> 11.1 of draft-ietf-geopriv-http-location-delivery-02.txt for the URN
> sub-namespace registration, and Section 11.2 of for the XML schema
> registration).
>
>
>
> Chris Newman wrote:
>> I expect HTTP bindings to address the concerns raised in BCP 56.
>> Unless the primary client for your protocol is a web browser, I would
>> strongly encourage registering a separate port.  In the SMTP world,
>> the primary source of interoperability problems is application-level
>> gateways/firewalls.  At this point it's inevitable we'll end up with
>> intrusive firewalls on port 80 that will break anything beyond stock
>> browser-based HTTP.  I encourage new HTTP-based protocols to register
>> a separate port so they have the opportunity to avoid such damage and
>> interoperability problems.  It also simplifies responsible firewall
>> operation by enabling port-based service restrictions that are more
>> scalable and less intrusive.
>>
>> I have yet to see any evidence that WSDL is useful in practice but
>> that may be due to my lack of experience with web services.
>>
>> I find Relax NG and/or XML schema useful for XML-based
>> protocols/formats whether or not they are built on top of HTTP.  My
>> understanding is that Relax NG is better for extensible entity-based
>> XML formats, whereas XML Schema is better for XML formats with strong
>> value typing.
>>
>> I haven't reviewed the DSKPP draft yet.
>>
>>                - Chris
>>
>> Hannes Tschofenig wrote on 9/13/07 14:56 +0200:
>>
>>> Hi all,
>>>
>>> I would like to solicit feedback regarding the HTTP binding described in
>>> DSKPP:
>>> http://www.ietf.org/internet-drafts/draft-ietf-keyprov-dskpp-00.txt
>>>
>>> I went through a couple of documents that describe an HTTP binding and
>>> noticed all of them are slightly different. If you, for example, take
>>> a look
>>> at another recent work, namely HELD, from the GEOPRIV working group
>>> then you
>>> will notice that the author incorporated a WSDL binding. The draft is
>>> here:
>>> http://www.ietf.org/internet-drafts/draft-ietf-geopriv-http-location-delive
>>> ry
>>>
>>> -01.txt
>>>
>>> Do people on this list have an opinion about the content they would
>>> like to
>>> see in these type of documents?
>>> What is the opinion regarding the usage of WSDL?
>>>
>>> Ciao
>>> Hannes
>>
>>
>>

---

From: "Hallam-Baker, Phillip" <[email-masked]>
Date: Thu, 4 Oct 2007 12:11:40 -0700

<hat chair=off>

This is a very troubling statement in my view.

Web Services is a standards based architecture with broad industry-wide support. Keith's RFC was written in 2002 before the Web Services architecture was developed. There is clearly a conflict between the views being advance here and established practice for the design and implementation of Web Services based specifications.

It is not helpful here if the IETF is going to insist on a separate definition of Web Services specifications that is not in sync with where the Web Services world is.

Either the BCP56 view is right in which case we need the proponents of this view to be talking to the wider Web Services world (OASIS, W3C) and arriving at a consensus position or the BCP56 view is obsolete and needs to be updated.

In either case this is an issue that the IAB needs to address. BCP56 is their work product, I believe. They need to be maintaining it.

In particular the idea that WSDL is somehow dispensible as a component in the Web Services architecture is not a widely held position within the Web Services world. 

The port number issue is somewhat more complex. The number of Web Services is rapidly expanding and the idea of one port per Web Service is simply not sustainable. We only have 65536 ports and we are going to have far more Web Services in use. 

We already have a technology that meets this need - the SRV record. Unlike some recent DNS records there is absoluely no problem with support for SRV record deployment. Practically all the DNS servers in service, including Windows support SRV. 

Rather than registering a port for the KEYPROV protocol we should instead define an SRV prefix. Wildcarding issues are not relevant in this particular case.

The firewall issues are pretty complex, far more complex than BCP56 allows. In particular the design of SOAP and WS-* is largely motivated by precisely the observation that port filtering is no longer a very effective firewall strategy. That's why the original SOAP architecture envisioned XML firewalls, UDDI and the like to route SOAP messages.

I don't think that either port filtering or SOAP firewalls is a viable near term strategy. Implementing a SOAP firewall is just too big an increase in complexity over traditional port filtering for it to be seen as a successor. SRV filtering on the other hand offers essentially the same degree of complexity.

</hat>

> -----Original Message-----
> From: Chris Newman [mailto:[email-masked]] 
> Sent: Tuesday, October 02, 2007 9:47 PM
> To: Hannes Tschofenig; [email-masked]
> Cc: [email-masked]
> Subject: [KEYPROV] Re: [APPS-REVIEW] Review of HTTP Binding for DSKPP
> 
> > thank you Chris for the pointer to RFC 3205 (BCP 56). I now read it 
> > and it is indeed a very interesting document. Too bad that I didn't 
> > came across it earlier.
> > Reading through that document I got the impression that the 
> > suggestions that can be found in there are not exercised by 
> today's protocol designs.
> 
> I largely support BCP 56 and as an IESG member I consider it 
> my duty and within my authority to enforce that BCP using my 
> best judgment.  However, some of the advice it gives could be 
> updated to make it better and it could use advice in 
> additional areas -- I would support an effort to revise it, 
> although the present HTTP WG proposal may not be the right 
> place to do that work.  I'm uncomfortable when my best 
> technical judgment disagrees with common practice and am 
> unlikely to use my IESG authority to permanently block 
> forward progress on a document in that case.  However, when 
> I'm aware of a BCP rule and agree with it, I consider it my 
> duty at a minimum to verify the community considered the rule 
> and had explicit community rough consensus to violate it.
> 
> > (c) New port number for DSKPP since the usage is so different from 
> > ordinary HTTP webbrowsing (This is quite controversal when 
> it comes to 
> > firewall traversal and might require more discussions. See
> > 
> > None of the protocols I have been working on defines a new 
> port. Can 
> > you give a reference to a recently developed protocol that 
> carries XML 
> > on top of HTTP that uses a new port number?
> 
> I'll give two examples of HTTP-based protocols with separate 
> ports where that was clearly the right technical choice in my opinion:
>   IPP: RFC 2910
>   SIP: RFC 3261
> 
> I'll also mention that the Mail Submission protocol runs on 
> port 587 primarily, but can also run on port 25.  That's a 
> practical way to (1) remain backwards compatible with 
> deployed usage or limitations. (2) provide a separate port 
> when it's helpful to avoid middle-box restrictions on an 
> overused/abused port like port 25.
> 
> It's my technical opinion there should be a separate port 
> registered for HTTP access to information used to validate 
> security credentials (CRLs, OCSP, etc) with port 80 as a 
> fallback for situations where the separate port can't be used 
> and for legacy use.  It's plausible to build an Internet 
> service where port 80 was intercepted by default for the 
> authentication screen, but this other port was (partially) 
> open so a client can get security information necessary to 
> verify the interception HTTP server's credentials.  I think 
> that would be a better architecture than running everything 
> over port 80 and forcing the port 80 application-level 
> middle-boxes to become ever more sophisticated and failure prone.
> 
> I have voted DISCUSS for discussion on this topic with 
> document authors, but I have not yet blocked forward progress 
> on any documents on this basis.
> 
> > (d) New URI scheme
> > (Currently we use the HTTP/HTTPS schemes but that does not 
> seem to be 
> > inline with the recommendations in BCP 56.)
> >
> > Neither HELD, SCVP, LoST nor DSKPP define a new URI scheme. 
> In LoST we 
> > had a URL registration in the document once, see Section 16.5 of 
> > draft-ietf-ecrit-lost-03, but removed it later (co-author of that 
> > document is Ted Hardie, the former Applications Area Director).
> 
> For things that only run on port 80, I generally wouldn't 
> expect a separate URL scheme.
> 
> > (e) WSDL Usage: Lisa and Chris do not see WSDL as something being 
> > useful. In fact, I haven't found a person who argued in 
> favor of WSDL. 
> > Hence, I believe we should avoid it.
> 
> To be precise: I have not yet seen any evidence that WSDL is 
> useful.  However, I have not educated myself on the protocol 
> sufficiently to have formed an opinion on whether or not it is useful.
> 
> > (f) Error Codes: RFC 3205 points to the problems of defining error 
> > codes when applications are layered on top of HTTP. The 
> suggestion is 
> > to essentially only use 200 (for complete success) and 500 (for 
> > complete failure) at the HTTP layer and to use 
> "application" specific 
> > error codes inside the layer application itself. We are essentially 
> > doing this. The only other error message that is being mentioned is 
> > 403 and since it is independent of the DSKPP protocol 
> interaction it should be fine as well.
> >
> > (g) HTTP client, proxy and server code: We added text regarding the 
> > expected behavior of clients, proxies and server in Section 5 of 
> > 
> http://www.ietf.org/internet-drafts/draft-ietf-keyprov-dskpp-0
0.txt. I 
> > guess we are doing fine there.
> >
> > The IANA registry for the MIME type should look similar to 
> the one in 
> > Section
> > We also need to add a registry for the schema and the 
> namespace (see 
> > Section
> >>> I went through a couple of documents that describe an 
> HTTP binding 
> >>> and noticed all of them are slightly different. If you, 
> for example, 
> >>> take a look at another recent work, namely HELD, from the GEOPRIV 
> >>> working group then you will notice that the author incorporated a 
> >>> WSDL binding. The draft is
> >>> here:
> >>> 
> >>> like to see in these type of documents?
> KEYPROV mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/keyprov
>

---

From: Chris Newman <[email-masked]>
Date: Fri, 05 Oct 2007 10:20:01 -0700

> This is a very troubling statement in my view.

I also find the situation troubling and welcome debate on the topic.

> Web Services is a standards based architecture with broad industry-wide
> support. Keith's RFC was written in 2002 before the Web Services architecture
> was developed. There is clearly a conflict between the views being advance
> here and established practice for the design and implementation of Web
> Services based specifications.
>
> It is not helpful here if the IETF is going to insist on a separate
> definition of Web Services specifications that is not in sync with where the
> Web Services world is.

When protocols are built using OASIS or W3C protocols such as services layered 
on SOAP over HTTP, then we're entering an area where the IETF lacks expertise. 
One of the litmus tests for such work is that it has rough consensus both 
within the IETF and with the other standards organizations.

However, I will observe that the IETF WebDAV family of protocols has gone in a 
quite different direction from the SOAP over HTTP web services protocols.  So 
our use of port 80 is already not in sync with the rest of the web services 
world.

> Either the BCP56 view is right in which case we need the proponents of this
> view to be talking to the wider Web Services world (OASIS, W3C) and arriving
> at a consensus position or the BCP56 view is obsolete and needs to be updated.

I suspect reality lies somewhere in the middle.

> In either case this is an issue that the IAB needs to address. BCP56 is their
> work product, I believe. They need to be maintaining it.

I'm not sure the IAB has the correct composition of individuals to address 
these concerns, particularly in the area of web services and web protocols.  It 
might be better if a revision to BCP 56 was driven by individuals with the 
appropriate expertise working with the IAB as necessary.

> In particular the idea that WSDL is somehow dispensible as a component in the
> Web Services architecture is not a widely held position within the Web
> Services world.

As an area director, I will not require WSDL until there is community consensus 
within the IETF that it should be required.  We already have far too many bars 
to jump over to get standards approved and I'm not inclined to add new ones 
absent evidence of substantial value.  The message was forwarded somewhat out 
of context -- I was asked if I would require a WSDL profile and I answered that 
question.  If I were asked the question "should a W3C/OASIS standards based web 
service have a WSDL profile?", my answer would be "ask the W3C/OASIS 
communities".

> The port number issue is somewhat more complex. The number of Web Services is
> rapidly expanding and the idea of one port per Web Service is simply not
> sustainable. We only have 65536 ports and we are going to have far more Web
> Services in use.
>
> We already have a technology that meets this need - the SRV record. Unlike
> some recent DNS records there is absoluely no problem with support for SRV
> record deployment. Practically all the DNS servers in service, including
> Windows support SRV.
>
> Rather than registering a port for the KEYPROV protocol we should instead
> define an SRV prefix. Wildcarding issues are not relevant in this particular
> case.

I find this proposal very interesting.  To me, the underlying value of separate 
ports is the benefit of architectural separation of components (security, 
software design, multi-vendor interoperability, etc).  If the community chooses 
an alternative mechanism to provide that value, I suspect that would address 
the underlying motivation of the discussion in BCP 56 about separate ports.

                - Chris

---

From: Mark Nottingham <[email-masked]>
Date: Tue, 9 Oct 2007 16:47:31 +1000

Without speaking to BCP56, a few things here caught my eye...

On 2007/10/05, at 5:11 AM, Hallam-Baker, Phillip wrote:
>
> Web Services is a standards based architecture with broad industry- 
> wide support. Keith's RFC was written in 2002 before the Web  
> Services architecture was developed. There is clearly a conflict  
> between the views being advance here and established practice for  
> the design and implementation of Web Services based specifications.

It would be interesting to see these claims supported -- e.g.,  
references for these standards, their architecture and evidence of  
broad support for those standards and that architecture.

> definition of Web Services specifications that is not in sync with  
> where the Web Services world is.

I'm sure both the W3C and OASIS would love it if the locus of the  
"Web Services world" could be nailed down, never mind the IETF.

> Either the BCP56 view is right in which case we need the proponents  
> of this view to be talking to the wider Web Services world (OASIS,  
> W3C) and arriving at a consensus position or the BCP56 view is  
> obsolete and needs to be updated.

The W3C, for one, has a very clear position about the relationship  
between the Web and Web Services, which includes use of HTTP; see  
documents by the TAG, for example.

> The port number issue is somewhat more complex. The number of Web  
> Services is rapidly expanding and the idea of one port per Web  
> Service is simply not sustainable. We only have 65536 ports and we  
> are going to have far more Web Services in use.

If you expand "Web Services" to include what some people are now  
calling "HTTP Web Services" or "RESTful Web Services," I agree that  
BCP56 needs some clarification.

Cheers,

--
Mark Nottingham       [email-masked]

---

From: "Hallam-Baker, Phillip" <[email-masked]>
Date: Tue, 9 Oct 2007 07:38:51 -0700

> From: [email-masked] [mailto:[email-masked]] 

> When protocols are built using OASIS or W3C protocols such as 
> services layered on SOAP over HTTP, then we're entering an 
> area where the IETF lacks expertise. 
> One of the litmus tests for such work is that it has rough 
> consensus both within the IETF and with the other standards 
> organizations.

Hence my proposal that the resolution here be that the IAB and apps area talk to the W3C TAG and OASIS TAB. What the resolution is matters a whole heap less than that we either agree on a common resolution or note that there are differences.

> However, I will observe that the IETF WebDAV family of 
> protocols has gone in a quite different direction from the 
> SOAP over HTTP web services protocols.  So our use of port 80 
> is already not in sync with the rest of the web services world.

WebDav started a long time ago, well before anyone was talking about SOAP or Web Services as a stack.

In the meantime the IETF has made a number of unfortunate choices, not least the attempt to prempt the W3C/OASIS work by racing BEEP to DRAFT standard despite the fact that it has virtually no platform support.

> > In either case this is an issue that the IAB needs to 
> address. BCP56 
> > is their work product, I believe. They need to be maintaining it.
> 
> I'm not sure the IAB has the correct composition of 
> individuals to address these concerns, particularly in the 
> area of web services and web protocols.  It might be better 
> if a revision to BCP 56 was driven by individuals with the 

If the IAB lacks the necessary individuals then ask NOMCON to fix this. The requirement here is for a group of people who are capable of talking to and evaluating input from people who are experts in Web Services, not to be experts themselves. 

> > In particular the idea that WSDL is somehow dispensible as 
> a component 
> > in the Web Services architecture is not a widely held 
> position within 
> > the Web Services world.
> 
> As an area director, I will not require WSDL until there is 
> community consensus within the IETF that it should be 
> required.  We already have far too many bars to jump over to 
> get standards approved and I'm not inclined to add new ones 
> absent evidence of substantial value.  The message was 
> forwarded somewhat out of context -- I was asked if I would 
> require a WSDL profile and I answered that question.  If I 
> were asked the question "should a W3C/OASIS standards based 
> web service have a WSDL profile?", my answer would be "ask 
> the W3C/OASIS communities".

I was pushing back against the impression you created.

The advice I would give to anyone writing a Web Service is that they should use WSDL because it will help them write the specification and help developers implement it. 

WSDL is not like writing a MIB, thinking about it as a profile is unhelpful. WSDL is a formal description of your protocol. It's a tool that you should think about in the same way that you would think about EBNF or such. You would not talk about an EBNF profile of RFC822 and its not helpful to talk about a WSDL profile of a Web Service.

> > We already have a technology that meets this need - the SRV record. 
> > Unlike some recent DNS records there is absoluely no problem with 
> > support for SRV record deployment. Practically all the DNS 
> servers in 
> > service, including Windows support SRV.
> >
> > Rather than registering a port for the KEYPROV protocol we should 
> > instead define an SRV prefix. Wildcarding issues are not 
> relevant in 
> > this particular case.
> 
> I find this proposal very interesting.  To me, the underlying 
> value of separate ports is the benefit of architectural 
> separation of components (security, software design, 
> multi-vendor interoperability, etc).  If the community 
> chooses an alternative mechanism to provide that value, I 
> suspect that would address the underlying motivation of the 
> discussion in BCP 56 about separate ports.

The problem with BCP 56 is that it is written to the assumption that the Internet will look pretty much the same in twenty years time as it does today. I think we have to at least have a contingency plan to deal with an Internet with a million protocols in active use.

The killer apps of the Internet today are almost exclusively human-machine protocols. We have almost no layer 7 protocols that are machine-machine. 

Humans have a limited number of needs and will tolerate a limited number of interaction modes. Over time the number of active killer human-machine protocols is unlikely to grow beyond 5 or so. The need to educate the human keeps complexity under control. 

That constraint goes away when machine-machine protocols are concerned. There are a dozen or more protocols in use just for card payment services. There is some consolidation but nothing like the consolidation we see in the human interaction space. It simply does not matter as much if EBay does or does not use the same payment protocol as Zix corporation. If a standards based service is introduced it will be in addition to the proprietary offerings and displacement will be slow.

I do see standardization pressures on Web Services themselves, as distinct from the platform. But unlike the human-machine space where standardization is motivated by the need for interoperation I see standards in the Web Services application world being driven by the need to reduce complexity in order to enable new development. The demand to standardize card acquisiton protocols is going to come from some new requirement (e.g. need to support EMV) that hits all the established operators, not standards for the sake of it. When VeriSign took over Cybercash we kept the old cybercash protocols alongside Payflow.

So fast forward a few decades and I think that the number of Web Services in use will have grown exponentially. That is a bad match for an architecture that requires a fixed resource be consumed per protocol.

The constraints I see here are

1) Need to support a very large number of Web Services (millions)
2) Need to provide a protocol description that can be easily read by a firewall

Port numbers meet the second need but not the first. SOAP firewalls meet the first but not the second. SOAP is expressly designed to expose the necessary information to a SOAP aware firewall but it is vastly more complex than port filtering.

SOAP aware firewalls will certainly have a place but I see them as something you would use to perform a second pass after you have made a basic go/nogo decision.

Pushing this to the naming layer makes sense to me.

---

From: "Hallam-Baker, Phillip" <[email-masked]>
Date: Tue, 9 Oct 2007 07:50:19 -0700

> From: Mark Nottingham [mailto:[email-masked]] 

> I'm sure both the W3C and OASIS would love it if the locus of 
> the "Web Services world" could be nailed down, never mind the IETF.

Yes, there is certainly an element of the old VMS manual problem. If you remember the days of the grey wall, there were 50 or so binders which each described one aspect of the VMS architecture in mind numbing detail. Most people simply gave up.

If you looked long enough you might have come across a volume called the VMS software architecture which was the key to the whole manual set. The architecture manual explained all the things you needed to know like how DCL worked, how AST completions worked and the like. Unless you happened to strike lucky and find that manual there was simply too much to absorb.

Web Services is worse because there isn't a manual.

> > Either the BCP56 view is right in which case we need the 
> proponents of 
> > this view to be talking to the wider Web Services world (OASIS,
> The W3C, for one, has a very clear position about the 
> relationship between the Web and Web Services, which includes 
> use of HTTP; see documents by the TAG, for example.

The IETF needs to be saying the same thing, not something different.

> > Services is rapidly expanding and the idea of one port per 
> Web Service 
> > is simply not sustainable. We only have 65536 ports and we 
> are going 
> If you expand "Web Services" to include what some people are 
> now calling "HTTP Web Services" or "RESTful Web Services," I 
> agree that

Well I don't use the term RESTfull because I don't think those following it are really follwing Fielding's architecture so much as they are doing Web Services over raw HTTP rather than with SOAP.

That is also fine and in fact that is why I think discussion of Web Services should begin with WSDL rather than with SOAP. You can do a Web Service with or without SOAP and you can do a Web Service with or without XML schema. But if you end up with something that you can't describe in WSDL it probably isn't a Web Service.

---

From: Julian Reschke <[email-masked]>
Date: Tue, 09 Oct 2007 17:46:45 +0200

Hallam-Baker, Phillip wrote:
> ...
> ...

I guess part of the problem is to distinguish between protocols that 
*use* HTTP the way it was designed to be used (auch as WebDAV or 
AtomPub) from protocols that just use HTTP as a transport layer (SOAP & 
friends).

Both WebDAV and AtomPub both use HTTP to edit/author HTTP resources. 
IMHO there's no point in running these operations on a different port 
from the one the resulting resources can be retrieved from.

Best regards, Julian

---

From: "Hallam-Baker, Phillip" <[email-masked]>
Date: Tue, 9 Oct 2007 09:37:08 -0700

I don't see what you mean by 'originally intended'.

Back in 1992 I was looking at the use of HTTP to control a physics experiment. The idea that the Web was simply a publication tool had not yet taken hold. At the time we had less than 100 Web users. So I think it counts as original intent.

>From a security point of view I am much more interested in improving the security of the Internet, rather than an Internet architecture that is likely to be ignored as impractical.

If we tell people not to use port 80 they will simply ignore us and use port 80 anyway. When Java first appeared on the Web I tried to persuade Gosling that Java content should be tagged application/java and not try to bypass content firewalls by tagging itself application/data. He ignored me even though it would have cost nothing to make the change at that point.

If on the other hand we give people a mechanism that they can use and which provides them with real benefits over raw port 80 we can persuade them down that route. A platform designer is not going to prevent Web Services being deployed on port 80 no matter what the IAB says. But a platform designer could possibly be persuaded to implement a Web Service connect call that employed the SRV mechanism by default, thus taking advantage of the load sharing capabilities it offers.

> From: Julian Reschke [mailto:[email-masked]] 
> Sent: Tuesday, October 09, 2007 11:47 AM
> To: Hallam-Baker, Phillip
> Cc: [email-masked]; Hannes Tschofenig; 
> [email-masked]; [email-masked]
> Subject: Re: [KEYPROV] Re: [APPS-REVIEW] Review of HTTP 
> Binding for DSKPP
> 
> protocols has 
> >> gone in a quite different direction from the SOAP over HTTP web 
> >> services protocols.  So our use of port 80 is already not in sync 
> >> with the rest of the web services world.
> > 
> > WebDav started a long time ago, well before anyone was 
> talking about SOAP or Web Services as a stack.
> > ...
> 
> AtomPub) from protocols that just use HTTP as a transport 
> layer (SOAP & friends).
> 
> IMHO there's no point in running these operations on a 
> different port from the one the resulting resources can be 
> retrieved from.
> 
> Best regards, Julian
>